routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\BukuTamuController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\FasilitasController;
use App\Http\Controllers\FasilitasKamarController;
use App\Http\Controllers\KamarController;
use App\Http\Controllers\PendapatanController;
use App\Http\Controllers\TipeKamarController;
use App\Http\Controllers\TransaksiController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [DashboardController::class, 'home'])->name('landing');
Route::get('kamar-hotel', [DashboardController::class, 'kamar'])->name('kamar.hotel');
Route::get('kamar-hotel-show/{id}', [DashboardController::class, 'showKamar'])->name('kamar.hotel.show');
Route::get('fasilias-hotel', [DashboardController::class, 'fasilitas'])->name('fasilitas.hotel');

Route::group(['middleware' => 'guest'], function(){
    Route::get('login', [AuthController::class, 'login'])->name('login');
    
    Route::post('signin', [AuthController::class, 'signin'])->name('signin');
    
    Route::post('signup', [AuthController::class, 'signup'])->name('signup');
    
    Route::get('register', [AuthController::class, 'register'])->name('register');
});

Route::group(['middleware' => 'auth'], function(){
    Route::post('logout', [AuthController::class, 'logout'])->name('logout');
    Route::resource('cart', CartController::class);
    Route::post('cart-destroy-all', [CartController::class, 'destroyAll'])->name('cart.destroy.all');
    Route::get('transaksi', [TransaksiController::class, 'index'])->name('transaksi.index');
    Route::post('transaksi-store', [TransaksiController::class, 'store'])->name('transaksi.store');
    Route::get('invoice/{id?}', [TransaksiController::class, 'invoice'])->name('transaksi.invoice');
    Route::get('invoice-show/{id?}', [TransaksiController::class, 'show'])->name('transaksi.invoice.show');
    Route::group(['middleware' => ['hasrole:admin']], function(){
        Route::resource('kamar', KamarController::class);
        Route::resource('fasilitas', FasilitasController::class);
        Route::resource('fasilitas-kamar', FasilitasKamarController::class);
        Route::resource('tipe-kamar', TipeKamarController::class);
    });
    Route::group(['middleware' => ['hasrole:guider']], function(){
        Route::get('buku-tamu', [BukuTamuController::class, 'index'])->name('buku.tamu.index');
        Route::get('buku-tamu/{id?}/show', [BukuTamuController::class, 'show'])->name('buku.tamu.show');
        Route::put('buku-tamu/{id?}/update', [BukuTamuController::class, 'update'])->name('buku.tamu.update');
        Route::get('pendapatan', [PendapatanController::class, 'index'])->name('pendapatan.index');
        Route::post('pendapatan/total', [PendapatanController::class, 'getTotalPendapatan'])->name('pendapatan.total');
    });
});

app/Models/Fasilitas.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Fasilitas extends Model
{
    use HasFactory;
    protected $guarded = [];
}

app/Http/Controllers/FasilitasController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\FasilitasRequest;
use App\Models\Fasilitas;
use Illuminate\Support\Facades\Storage;
use Yajra\DataTables\Facades\DataTables;

class FasilitasController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if(request()->ajax()){
            return DataTables::of(Fasilitas::get())
                ->addColumn('_', function($row){
                    return '<button type="button" class="btn btn-info btn-sm" onclick="view('.$row->id.')">Lihat</button>
                        <button type="button" class="btn btn-warning text-light btn-sm" onclick="edit('.$row->id.')">Edit</button>
                        <button type="button" class="btn btn-danger btn-sm" onclick="destroy('.$row->id.')">Hapus</button>';
                })
                ->editColumn('picture', function($row){
                    return "<img src=".asset('storage/'.$row->picture)." width='100' height='100'>";
                })
                ->rawColumns(['_', 'picture'])
                ->make(true);
        }
        return view('pages.fasilitas.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.fasilitas.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(FasilitasRequest $request)
    {
        $file = request()->file('picture');
        $filePath = $file->storeAs('fasilitas', time(), 'public');
        $req = [
            'name' => request('name'),
            'desc' => request('desc'),
            'picture' => $filePath
        ];

        if(Fasilitas::create($req)){
            return response()->json([
                'status' => true,
                'message' => 'Fasilias berhasil ditambahkan'
            ]);
        }
        return response()->json([
            'status' => false,
            'message' => 'Fasilitas gagal ditambahkan'
        ]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $model  = Fasilitas::find($id);
        return view('pages.fasilitas.show', compact('model'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $model  = Fasilitas::find($id);
        return view('pages.fasilitas.edit', compact('model'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(FasilitasRequest $request, $id)
    {
        $model = Fasilitas::find($id);
        $file = request()->file('picture');

        if($file){
            // delete file
            $path = str_replace('/', '\\', $model->picture);
            if(Storage::exists('public\\'.$path)){
                Storage::delete('public\\'.$model->picture);
            }

            // add file
            $filePath = $file->storeAs('fasilitas', time(), 'public');
        }

        $req = [
            'name' => request('name'),
            'desc' => request('desc'),
            'picture' => $filePath ?? $model->picture
        ];

        if($model->update($req)){
            return response()->json([
                'status' => true,
                'message' => 'Fasilitas berhasil diperbarui'
            ]);
        }

        return response()->json([
            'status' => true,
            'message' => 'Fasilitas gagal ditambahkan'
        ]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $model = Fasilitas::find($id);
        $path = str_replace('/', '\\', $model->picture);
        if(Storage::exists('public\\'.$path)){
            Storage::delete('public\\'.$model->picture);
        }

        if($model->delete()){
            return response()->json([
                'status' => true,
                'message' => 'Fasilitas berhasil dihapus'
            ]);
        }

        return response()->json([
            'status' => false,
            'message' => 'Fasilitas gagal dihapus'
        ]);
    }
}

resources/views/pages/fasilitas/create.blade.php
{!! Form::open(['id' => 'formCreate', 'enctype' => 'multipart/form-data']) !!}
    @include('pages.fasilitas.form')
    <div class="text-right">
        <button type="button" class="btn btn-secondary btn-sm" onclick="bootbox.hideAll()">Batal</button>
        <button type="button" class="btn btn-primary btn-sm" onclick="store()">Tambah</button>
    </div>
    <script>
        function showPreview(event){
            if(event.target.files.length > 0){
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#image').attr('src', e.target.result);
                };
                $('browse_gambar').attr('value', event.target.files);
                reader.readAsDataURL(event.target.files[0]);
            }
        }
    </script>
{!! Form::close() !!}

resources/views/pages/fasilitas/edit.blade.php
{!! Form::model($model, ['id' => 'formEdit', 'enctype' => 'multipart/form-data']) !!}
    @include('pages.fasilitas.form')
    <div class="text-right">
        <button type="button" class="btn btn-secondary btn-sm" onclick="bootbox.hideAll()">Batal</button>
        <button type="button" class="btn btn-primary btn-sm" onclick="update({{ $model->id }})">Ubah</button>
    </div>
    <script>
        function showPreview(event){
            if(event.target.files.length > 0){
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#image').attr('src', e.target.result);
                };
                $('browse_gambar').attr('value', event.target.files);
                reader.readAsDataURL(event.target.files[0]);
            }
        }
    </script>
{!! Form::close() !!}

resources/views/pages/fasilitas/form.blade.php
<div class="mb-3 text-center">
    @if(isset($model))
        <img id="image" src="{{ asset('storage/'.$model->picture) }}" class="w-75 rounded" alt="">
    @else
        <img id="image" src="" class="w-75 rounded" alt="">
    @endif
</div>
<div class="form-group">
    <label for="browse_gambar">Pilih Gambar</label>
    <div class="custom-file mb-3">
        <input name="picture" type="file" class="custom-file-input" id="browse_gambar" onchange="showPreview(event)" required>
        <label class="custom-file-label" for="browse_gambar">Pilih...</label>
    </div>
</div>
<div class="form-group">
    <label for="name">Nama Fasilitas</label>
    {!! Form::text('name', null, ['class' => 'form-control', 'id' => 'name']) !!}
</div>
<div class="form-group">
    <label for="tipe">Keterangan</label>
    {!! Form::textarea('desc', null, ['class' => 'form-control', 'id' => 'desc', 'rows' => '5']) !!}
</div>

resources/views/pages/fasilitas/form_script.blade.php
<script>
    var table;
    $(() => {
        table = $('#table').DataTable({
            searching: false,
            lengthChange: false,
            info: false,
            paging: false,
            processing: true,
            serverSide: true,
            ajax: '',
            responsive: true,
            columns: [
                {data: 'name', name: 'fasilias.name'},
                {data: 'desc', name: 'fasilitas.desc'},
                {data: 'picture', name: 'fasilitas.picture', class:"text-center", orderable: false},
                {data: '_', searchable: false}
            ]
        });
    });

    function create(){
        $.ajax({
            url: '{{ route('fasilitas.create') }}',
            success: (response) => {
                bootbox.dialog({
                    title: 'Tambah Fasilitas',
                    message: response,
                    closeButton: true
                });
            }
        })
    }

    function store(){
        let fd = new FormData();
        fd.append('picture', $('#browse_gambar').prop('files')[0]);
        fd.append('name', $('#name').val());
        fd.append('_token', '{{ csrf_token() }}');
        fd.append('desc', $('#desc').val());
        $('#formCreate .alert').remove();
        
        $.ajax({
            url: '{{ route('fasilitas.store') }}',
            type: 'post',
            cache: false,
            contentType: false,
            processData: false,
            data: fd,
            success: (response) => {
                if(response.status){
                    Swal.fire({
                        title: 'success',
                        text: response.message,
                        icon: 'success'
                    });
                    table.ajax.reload();
                }else {
                    Swal.fire({
                        title: 'gagal',
                        text: response.message,
                        icon: 'error'
                    });
                }
                bootbox.hideAll();
            },
            error: (err) => {
                var response = JSON.parse(err.responseText);
                $('#formCreate').prepend(validation(response));
            }
        });
    }

    function edit(id){
        let url = "{{ route('fasilitas.edit', ":id") }}"
        url = url.replace(':id', id);
        $.ajax({
            url,
            success: (response) => {
                bootbox.dialog({
                    title: 'Ubah Fasilitas',
                    message: response,
                    closeButton: true
                });
            }
        });
    }

    function update(id){
        let fd = new FormData();
        fd.append('picture', $('#browse_gambar').prop('files')[0]);
        fd.append('name', $('#name').val());
        fd.append('_token', '{{ csrf_token() }}');
        fd.append('_method', 'PUT');
        fd.append('desc', $('#desc').val());
        $('#formEdit .alert').remove();

        let url = "{{ route('fasilitas.update', ":id") }}";
        url = url.replace(':id', id);

        $.ajax({
            url,
            type: 'post',
            cache: false,
            contentType: false,
            processData: false,
            data: fd,
            success: (response) => {
                if(response.status){
                    Swal.fire({
                        title: 'success',
                        text: response.message,
                        icon: 'success'
                    });
                    table.ajax.reload();
                }else {
                    Swal.fire({
                        title: 'gagal',
                        text: response.message,
                        icon: 'error'
                    });
                }
                bootbox.hideAll();
            },
            error: (err) => {
                let response = JSON.parse(err.responseText);
                $('#formEdit').prepend(validation(response));
            }
        });
    }

    function view(id){
        let url = "{{ route('fasilitas.show', ":id") }}";
        url = url.replace(":id", id);

        $.ajax({
            url,
            success: (response) => {
                bootbox.dialog({
                    title: 'Detail Fasilitas',
                    message: response,
                    closeButton: true
                });
            }
        });
    }

    function destroy(id){
        let data = {'_token': "{{ csrf_token() }}", '_method': 'DELETE'};
        
        let url  = "{{ route('fasilitas.destroy', ":id") }}";
        url = url.replace(':id', id);

        Swal.fire({
            title: 'Yakin hapus data?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Hapus',
        }).then((result) => {
            if(result.isConfirmed){
                $.ajax({
                    url,
                    method: 'post',
                    data,
                    success: (response) => {
                        if(response.status){
                            Swal.fire({
                                title: 'success',
                                text: response.message,
                                icon: 'success'
                            });
                            table.ajax.reload();
                        }else {
                            Swal.fire({
                                title: 'gagal',
                                text: response.message,
                                icon: 'error'
                            });
                        }
                    }
                });
            }
        });
    }

    function validation(errors){
        var validations = '<div class="alert alert-danger">';
        $.each(errors.errors, function(i, error){
            validations += error[0]+'<br>';
        });
        validations += '</div>';
        return validations;
    }
</script>

resources/views/pages/fasilitas/index.blade.php
<x-adminLayout pageName="Fasilitas">
    <div class="d-flex justify-content-end mb-3">
        <button class="btn btn-success btn-sm text-end" onclick="create()">Tambah</button>
    </div>
    <table class="table table-bordered table-condensed" id="table">
        <thead>
            <tr>
                <th>Nama Fasilitas</th>
                <th>Keterangan</th>
                <th>Gambar</th>
                <th>Aksi</th>
            </tr>
        </thead>
        <tbody></tbody>
    </table>
    @slot('script')
        @include('pages.fasilitas.form_script')
    @endslot
</x-adminLayout>

resources/views/pages/fasilitas/show.blade.php
{!! Form::model($model, ['id' => 'formShow']) !!}
    <div class="mb-3 text-center">
        <img id="image" src="{{ asset('storage/'.$model->picture) }}" class="w-75 rounded" alt="">
    </div>
    <div class="container">
        <div class="row">
            <h6>Nama Fasilitas</h6>
        </div>
        <div class="row">
            <p>{{ $model->name }}</p>
        </div>
        <div class="row">
            <h6>Deskripsi</h6>
        </div>
        <div class="row">
            <p>{{ $model->desc }}</p>
        </div>
    </div>
    <div class="text-right">
        <button type="button" class="btn btn-secondary btn-sm" onclick="bootbox.hideAll()">Batal</button>
    </div>
{!! Form::close() !!}